<script lang="ts">
  import { onDestroy } from 'svelte'
  import GiPerspectiveDiceSixFacesRandom from 'svelte-icons/gi/GiPerspectiveDiceSixFacesRandom.svelte'
  import Board from './lib/Board.svelte'
  import GameOver from './lib/GameOver.svelte'
  import ModalRules from './lib/ModalRules.svelte'
  import StartGameButton from './lib/StartGameButton.svelte'
  import Rules from './Rules.svelte'
  import { isNewGameStarted, hasGameEnded } from './store'

  let isRulesModalOpen = false
  let shouldStartGame: boolean
  let isGameOver: boolean

  const unsubscribeStartGameStore = isNewGameStarted.subscribe(state => {
    shouldStartGame = state
  })
  const unsubscribeEndGameStore = hasGameEnded.subscribe(state => {
    isGameOver = state
  })

  onDestroy(() => {
    unsubscribeStartGameStore()
    unsubscribeEndGameStore()
  })

  function toggleRulesModal() {
    if (isGameOver) return

    isRulesModalOpen = !isRulesModalOpen
  }
</script>

<main class="h-screen w-screen overflow-hidden bg-slate-100">
  <header class="bg-violet-600 h-16 w-full flex items-center justify-center px-4 box-border">
    <h1 class="rubik-font text-4xl text-white font-bold text-center grow tracking-widest">Knucklebones</h1>
    <div class="rules-icon" on:click|preventDefault={toggleRulesModal} on:keydown>
      <GiPerspectiveDiceSixFacesRandom />
    </div>
  </header>

  {#if !shouldStartGame && !isGameOver}
    <div class="flex h-full items-center justify-center flex-col gap-8 ">
      <StartGameButton />

      <div class="p-6 w-4/6 bg-white border border-gray-200 rounded-lg shadow-md">
        <div class="flex items-center justify-center">
          <div class="card-rules-icon mr-2">
            <GiPerspectiveDiceSixFacesRandom />
          </div>
          <h3 class="rubik-font text-2xl font-medium leading-6 text-gray-900 tracking-widest uppercase">Rules</h3>
        </div>
        <Rules />
      </div>
    </div>
  {/if}

  {#if shouldStartGame || isGameOver}
    <Board />
  {/if}

  <ModalRules open={isRulesModalOpen} toggleModal={toggleRulesModal} />

  {#if isGameOver}
    <GameOver />
  {/if}
</main>

<style>
  div.rules-icon {
    color: white;
    width: 28px;
    cursor: pointer;
  }

  div.card-rules-icon {
    width: 28px;
  }
</style>
